;*******************************************************************************
;* Example program for the MiniRISC CPU.                                       *
;* 4 bit up/down counter with saturation.                                      *
;*******************************************************************************
    mov     r1, #0          ;r1 stores the value of the counter.
    mov     r2, #15         ;Last state when counting up.

cnt_loop:
    mov     0x80, r1        ;Display the counter value on the LEDs.
    mov     r15, 0x81       ;Read the state of the DIP switches.
    sub     r0, r15, r0     ;Count up, if all of the switches are off.
    jz      cnt_up

cnt_down:                   ;Down count.
    sub     r0, r1, r0      ;Check the last state.
    jz      cnt_loop
    sub     r1, #1          ;Decrement the value of the counter.
    jmp     cnt_loop

cnt_up:                     ;Up count
    sub     r0, r1, r2      ;Check the last state.
    jz      cnt_loop
    add     r1, #1          ;Increment the value of the counter.
    jmp     cnt_loop
