;*******************************************************************************
;* Example program for the MiniRISC CPU.                                       *
;* Knight Rider light effect with 2 LEDs.                                      *
;*******************************************************************************
DEF     LD      0x80        ; LED register (read/write)

start:
    mov     r1, #0xc0       ; r1 stores the state of the LEDs.
    mov     r2, #0          ; Shift direction: right (0) / left (1).
    mov     r3, #0x03       ; Final state in case of right shift.
    mov     r4, #0xc0       ; Final state in case of left shift.

shift_loop:
    mov     LD, r1          ; Update the LEDs.
    sub     r0, r2, r0      ; Check the shift direction.
    jnz     shift_l

shift_r:
    sr0     r1, r1          ; Shift right the value of the LEDs.
    sub     r0, r1, r3      ; Check the final state (0b00000011).
    jnz     shift_loop
    mov     r2, #1          ; Change the shift direction to left.
    jmp     shift_loop

shift_l:
    sl0     r1, r1          ; Shift left the value of the LEDs.
    sub     r0, r1, r4      ; Check the final state (0b11000000).
    jnz     shift_loop
    mov     r2, #0          ; Change the shift direction to right.
    jmp     shift_loop
