;*******************************************************************************
;* Example program for the MiniRISC CPU.                                       *
;* Calculates the sum of numbers from 1 to N (N: value of the DIP switches).   *
;*******************************************************************************
DEF     LED     0x80        ;LED register (read/writey)
DEF     SWITCH  0x81        ;DIP switch register (read-only)

start:
    mov     r1, #1          ;r1 is used as the loop variable.
    mov     r2, #0          ;r2 stores the sum. Initialize it to 0.
    mov     LED, r2         ;Display the current sum value on the LEDs.
    mov     r3, SWITCH      ;Get the final value of r1 from the DIP switches.

loop:
    add     r2, r2, r1      ;Add the next value to the sum.
    mov     LED, r2         ;Display the current sum value on the LEDs.
    add     r1, #1          ;Increment the loop variable.
    sub     r0, r3, r1      ;Exit from the loop if r1 > r3 (C is set).
    jnc     loop

end:
    jmp     end             ;Endless loop
