//******************************************************************************
//* MiniRISC CPU                                                               *
//*                                                                            *
//* Control signal value definitions.                                          *
//******************************************************************************


//******************************************************************************
//* Register file input data.                                                  *
//******************************************************************************
localparam REG_WR_ALU   = 2'b00;       //ALU result
localparam REG_WR_MEM   = 2'b01;       //Data memory
localparam REG_WR_CNST  = 2'b10;       //Constant


//******************************************************************************
//* ALU operand 2 and data memory address.                                     *
//******************************************************************************
localparam ALU_OP2_REGB = 1'b0;        //Register / indirect addressing
localparam ALU_OP2_CNST = 1'b1;        //Constant / absolute addressing


//******************************************************************************
//* ALU operation types.                                                       *
//******************************************************************************
localparam ALU_OP_MOVE  = 2'b00;       //Register move
localparam ALU_OP_ARITH = 2'b01;       //Arithmetic (addition, subtraction)
localparam ALU_OP_LOGIC = 2'b10;       //Logic (bitwise AND, OR, XOR)
localparam ALU_OP_SHIFT = 2'b11;       //Shift


//******************************************************************************
//* ALU arithmetic operations.                                                 *
//******************************************************************************
localparam ARITH_OP_ADD = 1'b0;        //Addition
localparam ARITH_OP_SUB = 1'b1;        //Subtraction


//******************************************************************************
//* ALU logic operations.                                                      *
//******************************************************************************
localparam LOGIC_OP_AND = 2'b00;       //Bitwise AND
localparam LOGIC_OP_OR  = 2'b01;       //Bitwise OR
localparam LOGIC_OP_XOR = 2'b10;       //Bitwise XOR

